# coding: utf-8

"""
    Sensorbucket API

    SensorBucket processes data from different sources and devices into a single standardized format.  An applications connected to SensorBucket, can use all devices SensorBucket supports.  Missing a device or source? SensorBucket is designed to be scalable and extendable. Create your own worker that receives data from an AMQP source, process said data and output in the expected worker output format.  Find out more at: https://developer.sensorbucket.nl/  Developed and designed by Provincie Zeeland and Pollex   # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: info@pollex.nl
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, Field, StrictFloat, StrictInt, StrictStr

class Measurement(BaseModel):
    """
    Measurement
    """
    uplink_message_id: StrictStr = Field(...)
    device_id: Union[StrictFloat, StrictInt] = Field(...)
    device_code: StrictStr = Field(...)
    device_description: Optional[StrictStr] = None
    device_latitude: Optional[Union[StrictFloat, StrictInt]] = None
    device_longitude: Optional[Union[StrictFloat, StrictInt]] = None
    device_altitude: Optional[Union[StrictFloat, StrictInt]] = None
    device_location_description: Optional[StrictStr] = None
    device_properties: Optional[Dict[str, Any]] = None
    device_state: Union[StrictFloat, StrictInt] = Field(...)
    sensor_id: Union[StrictFloat, StrictInt] = Field(...)
    sensor_code: StrictStr = Field(...)
    sensor_description: Optional[StrictStr] = None
    sensor_external_id: StrictStr = Field(...)
    sensor_properties: Optional[Dict[str, Any]] = None
    sensor_brand: Optional[StrictStr] = None
    sensor_archive_time: Optional[Union[StrictFloat, StrictInt]] = None
    datastream_id: StrictStr = Field(...)
    datastream_description: Optional[StrictStr] = None
    datastream_observed_property: StrictStr = Field(...)
    datastream_unit_of_measurement: StrictStr = Field(...)
    measurement_timestamp: StrictStr = Field(...)
    measurement_value: Union[StrictFloat, StrictInt] = Field(...)
    measurement_latitude: Optional[Union[StrictFloat, StrictInt]] = None
    measurement_longitude: Optional[Union[StrictFloat, StrictInt]] = None
    measurement_altitude: Optional[Union[StrictFloat, StrictInt]] = None
    measurement_properties: Optional[Dict[str, Any]] = None
    measurement_expiration: StrictStr = Field(...)
    created_at: Optional[StrictStr] = None
    __properties = ["uplink_message_id", "device_id", "device_code", "device_description", "device_latitude", "device_longitude", "device_altitude", "device_location_description", "device_properties", "device_state", "sensor_id", "sensor_code", "sensor_description", "sensor_external_id", "sensor_properties", "sensor_brand", "sensor_archive_time", "datastream_id", "datastream_description", "datastream_observed_property", "datastream_unit_of_measurement", "measurement_timestamp", "measurement_value", "measurement_latitude", "measurement_longitude", "measurement_altitude", "measurement_properties", "measurement_expiration", "created_at"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Measurement:
        """Create an instance of Measurement from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Measurement:
        """Create an instance of Measurement from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Measurement.parse_obj(obj)

        _obj = Measurement.parse_obj({
            "uplink_message_id": obj.get("uplink_message_id"),
            "device_id": obj.get("device_id"),
            "device_code": obj.get("device_code"),
            "device_description": obj.get("device_description"),
            "device_latitude": obj.get("device_latitude"),
            "device_longitude": obj.get("device_longitude"),
            "device_altitude": obj.get("device_altitude"),
            "device_location_description": obj.get("device_location_description"),
            "device_properties": obj.get("device_properties"),
            "device_state": obj.get("device_state"),
            "sensor_id": obj.get("sensor_id"),
            "sensor_code": obj.get("sensor_code"),
            "sensor_description": obj.get("sensor_description"),
            "sensor_external_id": obj.get("sensor_external_id"),
            "sensor_properties": obj.get("sensor_properties"),
            "sensor_brand": obj.get("sensor_brand"),
            "sensor_archive_time": obj.get("sensor_archive_time"),
            "datastream_id": obj.get("datastream_id"),
            "datastream_description": obj.get("datastream_description"),
            "datastream_observed_property": obj.get("datastream_observed_property"),
            "datastream_unit_of_measurement": obj.get("datastream_unit_of_measurement"),
            "measurement_timestamp": obj.get("measurement_timestamp"),
            "measurement_value": obj.get("measurement_value"),
            "measurement_latitude": obj.get("measurement_latitude"),
            "measurement_longitude": obj.get("measurement_longitude"),
            "measurement_altitude": obj.get("measurement_altitude"),
            "measurement_properties": obj.get("measurement_properties"),
            "measurement_expiration": obj.get("measurement_expiration"),
            "created_at": obj.get("created_at")
        })
        return _obj

