# coding: utf-8

"""
    Sensorbucket API

    SensorBucket processes data from different sources and devices into a single standardized format.  An applications connected to SensorBucket, can use all devices SensorBucket supports.  Missing a device or source? SensorBucket is designed to be scalable and extendable. Create your own worker that receives data from an AMQP source, process said data and output in the expected worker output format.  Find out more at: https://developer.sensorbucket.nl/  Developed and designed by Provincie Zeeland and Pollex   # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: info@pollex.nl
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt, StrictStr

class Sensor(BaseModel):
    """
    Sensor
    """
    id: Optional[Union[StrictFloat, StrictInt]] = None
    code: Optional[StrictStr] = None
    description: Optional[StrictStr] = None
    external_id: Optional[StrictStr] = None
    brand: Optional[StrictStr] = None
    archive_time: Optional[Union[StrictFloat, StrictInt]] = None
    properties: Optional[Dict[str, Any]] = None
    created_at: Optional[StrictStr] = None
    __properties = ["id", "code", "description", "external_id", "brand", "archive_time", "properties", "created_at"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Sensor:
        """Create an instance of Sensor from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> Sensor:
        """Create an instance of Sensor from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return Sensor.parse_obj(obj)

        _obj = Sensor.parse_obj({
            "id": obj.get("id"),
            "code": obj.get("code"),
            "description": obj.get("description"),
            "external_id": obj.get("external_id"),
            "brand": obj.get("brand"),
            "archive_time": obj.get("archive_time"),
            "properties": obj.get("properties"),
            "created_at": obj.get("created_at")
        })
        return _obj

